
#include "transfinbilinear.h"
#include <math.h>

// Macro definition for indexing a matrix with size = (m_nu+1,*)
// stored in a vector
#define id_pts(i,j) (((i)*(m_nu+1))+(j))

//-------------------------------------------------------------------------
TransfinBilinear::TransfinBilinear()
: m_nu( 0 )
, m_nv( 0 )
{
}
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
bool 
TransfinBilinear::setParam( vector<vector<int>> _loops )
{
 // Check for just one loop
 if( _loops.size() != 1 )
  return false;

 // Check for exactly four curves on loop
 vector<int> curveSbdvs = _loops[0];
 if( curveSbdvs.size() != 4 )
   return false;

 // Check for equal number of subdivisions on opposite curves of loop
 if( curveSbdvs[0] != curveSbdvs[2] )
  return false;
 if( curveSbdvs[1] != curveSbdvs[3] )
  return false;

 // Save parameters of valid boundary loop
 m_nu = curveSbdvs[0];
 m_nv = curveSbdvs[1];

 return true;
}
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
bool 
TransfinBilinear::generateMesh( vector<Point> _bound,
                                vector<Point>& _pts, vector<vector<int> >& _conn  )
{
 // Total number of boundary nodes must be consistent with
 // number of boundary segments
 if( _bound.size() != (m_nu+m_nv)*2)
  return false;

 int id_bound = 0;
 Point pt(0.0,0.0);
 int i;
 int j;

 // Allocate point vector in row major order
 for( i = 0; i <= m_nv; i++ )
 {
  for( j = 0; j <= m_nu; j++ )
  {
   _pts.push_back( pt );
  }
 }

 // Input nodes from first boundary curve
 i = 0;
 for( j = 0; j < m_nu; j++ )
 {
  _pts[id_pts(i,j)] = _bound[id_bound];
  id_bound++;
 }

 // Input node from second boundary curve
 j = m_nu;
 for( i = 0; i < m_nv; i++ )
 {
  /*** COMPLETE HERE - TRANSFINBILINEAR: 01 ***/


  /*** COMPLETE HERE - TRANSFINBILINEAR: 01 ***/
 }

 // Input node from third boundary curve
 /*** COMPLETE HERE - TRANSFINBILINEAR: 02 ***/






 /*** COMPLETE HERE - TRANSFINBILINEAR: 02 ***/

 // Input node from fourth boundary curve
 /*** COMPLETE HERE - TRANSFINBILINEAR: 03 ***/






 /*** COMPLETE HERE - TRANSFINBILINEAR: 03 ***/

 // Generate interior nodes
 /*** COMPLETE HERE - TRANSFINBILINEAR: 04 ***/
















 /*** COMPLETE HERE - TRANSFINBILINEAR: 04 ***/
  
 // Generate quadrilateral elements
 /*** COMPLETE HERE - TRANSFINBILINEAR: 05 ***/













 /*** COMPLETE HERE - TRANSFINBILINEAR: 05 ***/

 return true;
}
//-------------------------------------------------------------------------
